//---------------------------------------------------------------------------

#include <vcl.h>
#include <algorithm>
#include <functional>
#include <string>
#include <iostream>

#include "carray.hpp"
#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;


std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

template <class T>
inline void PRINT_ELEMENTS (const T& coll, const char* optcstr="")
{
  typename T::const_iterator pos;
  std::cout << ToRus(optcstr);
  for (pos=coll.begin(); pos!=coll.end(); ++pos) {
    std::cout <<*pos <<' ';
  }
  std::cout << std::endl;
}


int main(int argc, char* argv[])
{
  carray<int,10> a;

  for (unsigned i=0; i<a.size(); ++i) {
    a[i] = i+1;
  }
  cout << ToRus(" :\n");
  PRINT_ELEMENTS(a);

  reverse (a.begin(),a.end());
  cout << ToRus("   :\n");
  PRINT_ELEMENTS(a);

  transform(a.begin(),a.end(),  // 
            a.begin(),          // 
            negate<int>());     // 
  cout << ToRus("  :\n");
  PRINT_ELEMENTS(a);

  getch();
  return 0;
}

//---------------------------------------------------------------------------








